vexpower = {}
vexpower.combopoints = 0
vexpower.infight = false
vexpower.energytype = "ENERGY"
vexpower.maxwidth = 0
vexpower.maxenergy = 100
vexpower.maxenergy_prev = 100
vexpower.currentenergy = 100
vexpower.currentenergy_prev = 100
vexpower.markers = {nil}
vexpower.maxcps = 5
vexpower.currentcps = 0
vexpower.currentcps_prev = 0
vexpower.show = false
vexpower.stealth = false
vexpower.class = ""
vexpower.cpsbars = {}
vexpower.cpsbars_anigrps = {}
vexpower.cpsbars_anis = {}
vexpower.testmode = false
vexpower.testmodetime = 0
vexpower.spec = 1
vexpower.moveable = false

vexpower.AceConfigDialog = LibStub("AceConfigDialog-3.0", true)
vexpower.AceConfig = LibStub("AceConfig-3.0", true)
vexpower.AceConsole= LibStub("AceConsole-3.0", true)
vexpower.LSM = LibStub("LibSharedMedia-3.0", true)
vexpower.LSMWidgets = LibStub("AceGUI-3.0-SharedMediaWidgets", true)

SLASH_vexpower1 = "/vexpower"
SLASH_vexpower2 = "/vexp"
SLASH_vexpower3 = "/vexpowa"
function SlashCmdList.vexpower(msg, editbox)
	if 	msg == "" or msg == "options" or msg == "option" or msg == "config" or msg == "configs" then
		InterfaceOptionsFrame_OpenToCategory(vexpower.options.main)
	elseif msg == "defaults" then
		print("|CFFFF7D0AVex Power|r - defaults loaded")
		vexpower_loaddefaults(true)
	elseif msg == "test" then
		vexpower_movable()
	elseif msg == "lock" then
		vexpower_movable()
	elseif msg == "enable" then
		if vexpower_parameters["frame"]["show"] then
			vexpower_parameters["frame"]["show"]=false
			vexpower_showEnergybars()
			print("|CFFFF7D0AVex Power|r - Addon disabled")
		else
			vexpower_parameters["frame"]["show"]=true
			vexpower_showEnergybars()
			print("|CFFFF7D0AVex Power|r - Addon enabled")
		end
	else
		print ("|CFFFF7D0A Vex Power|r cmd list")
		print ("|CFFFF7D0A/vexpower|r and |CFFFF7D0A/vexp|r can be used")
		print ("|CFFFF7D0A/vexpower|r option/options/config/configs - opens the option frame")
		print ("|CFFFF7D0A/vexpower|r defaults - resets the addon to defaults")
	end
end

function vexpower_onEvent(self, event, arg1, arg2, ...)
	if 		event == "PLAYER_LOGIN" 				then
		vexpower_initialize(false)		
	elseif 	event == "PLAYER_REGEN_DISABLED"		then vexpower.infight=true vexpower_showEnergybars() vexpower_setEnergybarColor()
	elseif 	event == "PLAYER_REGEN_ENABLED"			then vexpower.infight=false vexpower_showEnergybars() vexpower_setEnergybarColor()
	elseif 	event == "UPDATE_STEALTH" 				then vexpower.stealth=IsStealthed() vexpower_showEnergybars()
	elseif 	event == "UNIT_DISPLAYPOWER"			then vexpower_setEnergyType() vexpower_showEnergybars() vexpower_changeEnergy(true)
	elseif 	event == "ACTIVE_TALENT_GROUP_CHANGED"	then vexpower_setSpec() vexpower_setMarkers()
	end
end

function vexpower_setEnergyType()
	vexpower.energytype = select(2, UnitPowerType("player"))
	vexpower_setEnergybarColor()
end

function vexpower_movable(movable)
	if movable == nil then
		movable = not(vexpower_MainFrame:IsMovable())
		if movable then
			print("|CFFFF7D0AVex Power|r - Frame is now movable")
		else
			print("|CFFFF7D0AVex Power|r - Frame is not movable anymore")
		end
	end
	vexpower_MainFrame:SetMovable(movable)
	vexpower_energybarbg:EnableMouse(movable)
end

function vexpower_saveFramePos()
	local anchor1 = select(1, vexpower_MainFrame:GetPoint())
	local anchor2 = select(3, vexpower_MainFrame:GetPoint())
	local x = select(4, vexpower_MainFrame:GetPoint())
	local y = select(5, vexpower_MainFrame:GetPoint())
	
	
	vexpower_parameters["frame"]["energy"]["position"]["anchor"] = anchor2
	vexpower_parameters["frame"]["energy"]["position"]["anchorFrame"] = anchor1
	vexpower_parameters["frame"]["energy"]["position"]["x"] = x
	vexpower_parameters["frame"]["energy"]["position"]["y"] = y
end

function vexpower_onUpdate()
	if vexpower_parameters["frame"]["show"] and not(vexpower.testmode) then
		if UnitPower("player") ~= vexpower.currentenergy then vexpower_changeEnergy() end
		
		if vexpower_getCpsCurrent() ~= vexpower.currentcps then vexpower_changeCps() end
		
		if vexpower_getCpsMax() ~= vexpower.maxcps then vexpower_initialize(true) end
	end
end

function vexpower_initialize(refresh)
	vexpower_loaddefaults()
	if not(refresh) then
		print("|CFFFF7D0AVex Power|r loaded")
		vexpower_energybarbg = CreateFrame("Frame", nil, vexpower_MainFrame)
		vexpower_energyTextbar = CreateFrame("Frame", nil, vexpower_energybarbg)
		vexpower_energybar = CreateFrame("Frame", nil, vexpower_energybarbg)
		vexpower_energybarDif = CreateFrame("Frame", nil, vexpower_energybarbg)
		vexpower_energytext_left = vexpower_energyTextbar:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		vexpower_energytext_right = vexpower_energyTextbar:CreateFontString(nil, "OVERLAY", "GameFontNormal")
		vexpower_cpsbar = CreateFrame("Frame", nil, vexpower_MainFrame)
	end
	
	vexpower_setSpec()
	
	vexpower_setMaxWidth()
	vexpower_setClass()
	if not(vexpower.testmode) then
		vexpower_setCpsMax()
		vexpower_setCpsCurrent()
		vexpower_setEnergyCurrent()
		vexpower_setEnergyType()
	end
	
	vexpower_setMainFrame()
	vexpower_setEnergybarBG()
	vexpower_setEnergybar()
	vexpower_setEnergybarDif()
	vexpower_setEnergyTextbar()
	vexpower_setFontStrings()
	vexpower_changeEnergyText()
	
	vexpower_setCpsBars()
	
	vexpower_showEnergybars()
	vexpower_setMarkers()
	
	if not(vexpower.testmode) then
		vexpower_changeEnergy()
	end
	
	vexpower_movable(false)
	
	if not(refresh) then
		vexpower.options = {}
		vexpower.options.main = vexpower.AceConfigDialog:AddToBlizOptions("Vex Power", "Vex Power")
		vexpower.options.frame = vexpower.AceConfigDialog:AddToBlizOptions("VexP EnergyBar", "VexP EnergyBar", "Vex Power")
		vexpower.options.text = vexpower.AceConfigDialog:AddToBlizOptions("VexP Text", "VexP Text", "Vex Power")
		vexpower.options.cps = vexpower.AceConfigDialog:AddToBlizOptions("VexP ComboPoints", "VexP ComboPoints", "Vex Power")
		vexpower.options.markers = vexpower.AceConfigDialog:AddToBlizOptions("VexP Markers", "VexP Markers", "Vex Power")
		vexpower.options.show = vexpower.AceConfigDialog:AddToBlizOptions("VexP Show/Enable", "VexP Show/Enable", "Vex Power")
		vexpower.options.profiles = vexpower.AceConfigDialog:AddToBlizOptions("VexP Profiles", "VexP Profiles", "Vex Power")
	end
	vexpower.AceConfig:RegisterOptionsTable("Vex Power", vexpower.panel_main(), {})
	vexpower.AceConfig:RegisterOptionsTable("VexP EnergyBar", vexpower.panel_energybar(), {})
	vexpower.AceConfig:RegisterOptionsTable("VexP Text", vexpower.panel_text(), {})
	vexpower.AceConfig:RegisterOptionsTable("VexP ComboPoints", vexpower.panel_cps(), {})
	vexpower.AceConfig:RegisterOptionsTable("VexP Markers", vexpower.panel_markers(), {})
	vexpower.AceConfig:RegisterOptionsTable("VexP Show/Enable", vexpower.panel_show(), {})
	vexpower.AceConfig:RegisterOptionsTable("VexP Profiles", vexpower.panel_profiles(), {})
end

function vexpower_setSpec()
	vexpower.spec = GetActiveTalentGroup(false, false)	-- OLD
	--vexpower.spec = GetActiveSpecGroup(false, false)	-- MoP
end

function vexpower_setMarkers()
	--Clear Markers
	for i=1,#vexpower.markers do
		if vexpower.markers[i] ~= nil then
			vexpower.markers[i]:Hide()
		end
		vexpower.markers[i]=nil
	end
	vexpower.markers = {}
	
	--Set new markers
	local markers = vexpower_parameters["frame"]["energy"]["markers"]["points"]
	for key,val in pairs(markers) do
		vexpower_insertMarker(vexpower_getEnergyWidth(val))
	end
	--Set new spec markers
	if vexpower.spec == 1 then 	markers = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_a"]
	else						markers = vexpower_parameters["frame"]["energy"]["markers"]["points_spec_b"] end
	if markers ~=nil then
		for key,val in pairs(markers) do
			vexpower_insertMarker(vexpower_getEnergyWidth(val))
		end
	end
end

function vexpower_insertMarker(pos)
	if pos < vexpower.maxwidth then
		local temp = CreateFrame("Frame", nil, vexpower_energyTextbar)
		temp:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
						edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=vexpower_parameters["frame"]["energy"]["markers"]["border"]["size"]})
							
		if vexpower_parameters["frame"]["energy"]["markers"]["color_likebg"] then
			if vexpower_parameters["frame"]["energy"]["typecolored"] then
				temp:SetBackdropColor(	PowerBarColor[vexpower.energytype].r,
										PowerBarColor[vexpower.energytype].g,
										PowerBarColor[vexpower.energytype].b,
										vexpower_parameters["frame"]["energy"]["markers"]["color"]["a"])
			else
				temp:SetBackdropColor(	vexpower_parameters["frame"]["energy"]["color"]["r"],
										vexpower_parameters["frame"]["energy"]["color"]["g"],
										vexpower_parameters["frame"]["energy"]["color"]["b"],
										vexpower_parameters["frame"]["energy"]["markers"]["color"]["a"])
			end
		else
			temp:SetBackdropColor(vexpower_parameters["frame"]["energy"]["markers"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["markers"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["markers"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["markers"]["color"]["a"])
		end
		
		
		if vexpower_parameters["frame"]["energy"]["markers"]["border"]["color_likebg"] then
			if vexpower_parameters["frame"]["energy"]["typecolored"] then
				temp:SetBackdropBorderColor(	PowerBarColor[vexpower.energytype].r,
										PowerBarColor[vexpower.energytype].g,
										PowerBarColor[vexpower.energytype].b,
										vexpower_parameters["frame"]["energy"]["color"]["a"])
			else
				temp:SetBackdropBorderColor(	vexpower_parameters["frame"]["energy"]["color"]["r"],
										vexpower_parameters["frame"]["energy"]["color"]["g"],
										vexpower_parameters["frame"]["energy"]["color"]["b"],
										vexpower_parameters["frame"]["energy"]["color"]["a"])
			end
		else
			temp:SetBackdropBorderColor(vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["markers"]["border"]["color"]["a"])
		end
											
											
		temp:SetWidth(vexpower_parameters["frame"]["energy"]["markers"]["width"])
		temp:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2)-4)
		
		temp:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT", pos, -vexpower_parameters["frame"]["energy"]["border"]["size"]-2)
		temp:Show()
		
		table.insert(vexpower.markers,#vexpower.markers+1, temp)
	end
end

function vexpower_setMaxWidth()
	local newwidth = vexpower_parameters["frame"]["energy"]["size"]["width"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2)
	if vexpower.maxwidth ~= newwidth then
		vexpower.maxwidth = newwidth
		vexpower_setMarkers()
	end
end

function vexpower_setEnergyMax()
	if UnitPowerMax("player") ~= vexpower.maxenergy then
		vexpower.maxenergy_prev = vexpower.maxenergy
		vexpower.maxenergy = UnitPowerMax("player")
		vexpower_setMarkers()
	end
end

function vexpower_setEnergyCurrent()
	local new = UnitPower("player")
	if new ~= vexpower.currentenergy then
		vexpower.currentenergy_prev = vexpower.currentenergy
		vexpower.currentenergy = new
	end
end

function vexpower_getEnergyWidth(energy)
	local width = 0
	if vexpower.maxenergy~=0 then
		if not(string.find(energy, "%%")) then
			width = (energy / vexpower.maxenergy) * vexpower.maxwidth
		else
			local energypercentage = string.gsub(energy, "%%", "")
			energypercentage = energypercentage/100
			width = energypercentage * vexpower.maxwidth
		end
	end
	if width == 0 then width = 1 end
	return width
end

function vexpower_getCpsCurrent(change)
	local new = 0
	
	if vexpower.class == "DRUID" or vexpower.class == "ROGUE"	then new = GetComboPoints("player")
	elseif vexpower.class == "PALADIN" 							then new = UnitPower("player", 9)
	elseif vexpower.class == "MONK"								then new = UnitPower("player", 12) 
	elseif vexpower.class == "PRIEST"							then new = UnitPower("player", 13) 
	elseif vexpower.class == "WARLOCK" 							then new = UnitPower("player", 7)
	end
	
	if change ~= nil then new = vexpower.currentcps+change end

	return new
end

function vexpower_setCpsCurrent(change)
	local new = vexpower_getCpsCurrent(change)
	
	if change ~= nil then new = vexpower.currentcps+change end
	
	if new ~= vexpower.currentcps then
		vexpower.currentcps_prev = vexpower.currentcps
		vexpower.currentcps = new
	end
end

function vexpower_setClass()
	vexpower.class = select(2, UnitClass("player"))
end

function vexpower_getCpsMax()
	local temp = 0
	if vexpower.class == "ROGUE"			then temp = 5	
	elseif vexpower.class == "PALADIN"		then temp = UnitPowerMax("player", 9)
	elseif vexpower.class == "MONK"			then temp = UnitPowerMax("player", 12) 
	elseif vexpower.class == "DRUID"		then temp = 5
	elseif vexpower.class == "PRIEST"		then temp = UnitPowerMax("player", 13) 
	elseif vexpower.class == "WARLOCK"		then temp = UnitPowerMax("player", 7) end
	return temp
end

function vexpower_setCpsMax()
	vexpower.maxcps = vexpower_getCpsMax()
end

function vexpower_changeCps(change)
	vexpower_setCpsCurrent(change)
	if vexpower.currentcps > vexpower.currentcps_prev then
		--CPs built
		for i=1, vexpower.currentcps do
			vexpower_setCpsBarsBGColor(i, true)
			if vexpower.cpsbars_anigrps[i]:IsPlaying() then vexpower.cpsbars_anigrps[i]:Stop() end
			vexpower.cpsbars[i]:Show()
		end
	else
		--CPs used
		for i=1, vexpower.maxcps do
			vexpower_setCpsBarsBGColor(i, true)
		end
		
		local cpsLost = vexpower.currentcps_prev-vexpower.currentcps
		
		for i=1, cpsLost do
			local bar = vexpower.currentcps_prev+1-i
			vexpower_setCpsBarsBGColor(bar, false) vexpower.cpsbars_anigrps[bar]:Play()
		end
	end
end

function vexpower_changeEnergy(energyTypeChanged, newenergy)
	if vexpower.show then
		if energyTypeChanged then
			if vexpower_energybarDif_anigrp:IsPlaying() then
				vexpower_energybarDif_anigrp:Stop()
			end
			if vexpower_energybar_anigrp:IsPlaying() then
				vexpower_energybar_anigrp:Stop()
			end
			vexpower_energybar:SetWidth(vexpower.maxwidth)
			vexpower_changeEnergy()
		else
			if not(vexpower_energybar_anigrp:IsPlaying()) then
				if newenergy ~= nil then
					vexpower.currentenergy_prev = vexpower.currentenergy
					vexpower.currentenergy = vexpower.currentenergy + newenergy
				else vexpower_setEnergyCurrent() end
				vexpower_setEnergyMax()
				vexpower_changeEnergyText()
				local maxenergy = vexpower.maxenergy
				if maxenergy == 0 then maxenergy = 1 end
				local barfactor_current = vexpower.currentenergy_prev/maxenergy
				local barfactor_new = vexpower.currentenergy/maxenergy
				local barfactor = 0
				
				if barfactor_current ~= 0 then 
					barfactor = barfactor_new/barfactor_current
				end
				
				local newWidth = vexpower_getEnergyWidth(vexpower.currentenergy)
								
				if barfactor < 1 and barfactor > 0 then
					local oldWidth = vexpower_getEnergyWidth(vexpower.currentenergy_prev)
					local difWidth = oldWidth - newWidth
					vexpower_energybar_ani:SetScale(barfactor, 1)
					if vexpower.energytype == "RAGE" or vexpower.energytype == "RUNIC_POWER" then
						vexpower_energybar_anigrp:SetScript("onFinished", function () vexpower_energybar:SetWidth(newWidth) end)
					end
					vexpower_energybar_anigrp:Play()
					
					if oldWidth<=vexpower.maxwidth then
						vexpower_energybarDif:SetWidth(difWidth)
						vexpower_energybarDif:ClearAllPoints()
						vexpower_energybarDif:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT",
									vexpower_parameters["frame"]["energy"]["border"]["size"]+newWidth,
									-vexpower_parameters["frame"]["energy"]["border"]["size"])
							vexpower_energybarDif_anigrp:Play()
					else
						vexpower_energybarDif:Hide()
					end
				else 
					vexpower_energybar:SetWidth(newWidth)
				end
				vexpower_setEnergybarColor()
			end
		end
	end
end

function vexpower_changeEnergyText()
	local lefttemplate = vexpower_parameters["frame"]["energy"]["text"]["left"]["text"]
	local righttemplate = vexpower_parameters["frame"]["energy"]["text"]["right"]["text"]
	local percenergy = 0
	if vexpower.maxenergy ~= 0 then	percenergy = math.floor((vexpower.currentenergy/vexpower.maxenergy)*100) end
	lefttemplate = string.gsub(lefttemplate, "{CurrentEnergy}", vexpower.currentenergy)
	lefttemplate = string.gsub(lefttemplate, "{CurrentManaSmart}", vexpower_GetEnergyShort(vexpower.currentenergy,1))
	lefttemplate = string.gsub(lefttemplate, "{CurrentManaShort}", vexpower_GetEnergyShort(vexpower.currentenergy))
	lefttemplate = string.gsub(lefttemplate, "{MaxEnergy}", vexpower.maxenergy)
	lefttemplate = string.gsub(lefttemplate, "{MaxManaSmart}", vexpower_GetEnergyShort(vexpower.maxenergy,1))
	lefttemplate = string.gsub(lefttemplate, "{MaxManaShort}", vexpower_GetEnergyShort(vexpower.maxenergy))
	lefttemplate = string.gsub(lefttemplate, "{MissingEnergy}", vexpower.maxenergy-vexpower.currentenergy)
	lefttemplate = string.gsub(lefttemplate, "{PercEnergy}", tostring(percenergy).."%%")
	lefttemplate = string.gsub(lefttemplate, "{CurrentCPs}", tostring(vexpower.currentcps))
	lefttemplate = string.gsub(lefttemplate, "{MaxCPs}", tostring(vexpower.maxcps))
	
	righttemplate = string.gsub(righttemplate, "{CurrentEnergy}", vexpower.currentenergy)
	righttemplate = string.gsub(righttemplate, "{CurrentManaSmart}", vexpower_GetEnergyShort(vexpower.currentenergy,1))
	righttemplate = string.gsub(righttemplate, "{CurrentManaShort}", vexpower_GetEnergyShort(vexpower.currentenergy))
	righttemplate = string.gsub(righttemplate, "{MaxEnergy}", vexpower.maxenergy)
	righttemplate = string.gsub(righttemplate, "{MaxManaSmart}", vexpower_GetEnergyShort(vexpower.maxenergy,1))
	righttemplate = string.gsub(righttemplate, "{MaxManaShort}", vexpower_GetEnergyShort(vexpower.maxenergy))
	righttemplate = string.gsub(righttemplate, "{MissingEnergy}", vexpower.maxenergy-vexpower.currentenergy)
	righttemplate = string.gsub(righttemplate, "{PercEnergy}", ""..percenergy.."%%")
	righttemplate = string.gsub(righttemplate, "{CurrentCPs}", tostring(vexpower.currentcps))
	righttemplate = string.gsub(righttemplate, "{MaxCPs}", tostring(vexpower.maxcps))
	
	vexpower_energytext_left:SetText(lefttemplate)
	vexpower_energytext_right:SetText(righttemplate)
end

function vexpower_GetEnergyShort(amount, dec)
	local returnvalue = ""
	if dec == 1 then
		local amount = tonumber(amount)/100
		amount = vexpower_CeilNumber(tonumber(amount))
		amount = tostring(amount / 10)
		if string.find(amount, "%.") == nil then
			amount = amount..".0"
		end
		returnvalue = amount
	else
		local amount = tonumber(amount)/1000
		amount = vexpower_CeilNumber(tonumber(amount))
		returnvalue = tostring(amount)
	end
	return returnvalue
end

function vexpower_CeilNumber(amount)
	local returnvalue = ""
	amount = tostring(amount)
	if string.find(amount, "%.") ~= nil then
		local amount_l = string.gsub(amount, "%.%d+$", "")
		local amount_r = string.gsub(amount, "^%d+%.", "0.")
		amount_l = tonumber(amount_l)
		amount_r = tonumber(amount_r)
		if amount_r >= 0.5 then
			amount_l = amount_l+1
		end
		returnvalue = amount_l
	else
		returnvalue = tonumber(amount)
	end
	return returnvalue
end

function vexpower_setCpsBarsBGColor(cp, standard)
	if vexpower.cpsbars[cp] ~=nil then
		local color = tostring(cp)
		if vexpower_parameters["frame"]["combo"]["bg"]["allowchange"] and vexpower.currentcps >= tonumber(vexpower_parameters["frame"]["combo"]["bg"]["cpchange"]) then
			if (vexpower_parameters["frame"]["combo"]["bg"]["cpchangeonly"] and cp <= tonumber(vexpower_parameters["frame"]["combo"]["bg"]["cpchange"])) or
						not(vexpower_parameters["frame"]["combo"]["bg"]["cpchangeonly"])  				then color = "change"
			end
		end
		if not(standard) then color = "used" end
		vexpower.cpsbars[cp]:SetBackdropColor(	vexpower_parameters["frame"]["combo"]["bg"]["color"][color]["r"],
												vexpower_parameters["frame"]["combo"]["bg"]["color"][color]["g"],
												vexpower_parameters["frame"]["combo"]["bg"]["color"][color]["b"],
												vexpower_parameters["frame"]["combo"]["bg"]["color"][color]["a"])
	end
end

function vexpower_setCpsBars()
	if not(vexpower.testmode) then
		if vexpower.cpsbars ~= nil then
			for i=1, #vexpower.cpsbars do
				if vexpower.cpsbars[i] ~= nil then vexpower.cpsbars[i]:Hide() end
			end
		end
	end
	
	local offset_total = vexpower_parameters["frame"]["combo"]["measure"]["offset"]*2
	local gap_total = (vexpower.maxcps-1)*vexpower_parameters["frame"]["combo"]["measure"]["gap"]
	
	local width = 0
	if vexpower.maxcps == 0 then width = (vexpower_parameters["frame"]["energy"]["size"]["width"] - gap_total - offset_total)
	else 						 width = (vexpower_parameters["frame"]["energy"]["size"]["width"] - gap_total - offset_total)/vexpower.maxcps end

	local start = {}
	start[1] = vexpower_parameters["frame"]["combo"]["measure"]["offset"]
	if vexpower.maxcps > 1 then
		for i=2, vexpower.maxcps do
			start[i] = start[i-1]+width+vexpower_parameters["frame"]["combo"]["measure"]["gap"]
		end
	end
	
	local animationduration = 0.3
	
	
	
	--Setup CPs
	for i=1, vexpower.maxcps do
		
		if not(vexpower.testmode) then
			vexpower.cpsbars[i] = CreateFrame("Frame", nil, vexpower_cpsbar)
		end
		vexpower.cpsbars[i]:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false,
											edgeSize=vexpower_parameters["frame"]["combo"]["border"]["size"]})
		vexpower_setCpsBarsBGColor(i, true)
		vexpower.cpsbars[i]:SetBackdropBorderColor(vexpower_parameters["frame"]["combo"]["border"]["color"]["r"],
														vexpower_parameters["frame"]["combo"]["border"]["color"]["g"],
														vexpower_parameters["frame"]["combo"]["border"]["color"]["b"],
														vexpower_parameters["frame"]["combo"]["border"]["color"]["a"])
		vexpower.cpsbars[i]:SetHeight(vexpower_parameters["frame"]["combo"]["measure"]["height"])
		
		if not(vexpower.testmode) then
			if vexpower.currentcps > 0 then vexpower.cpsbars[i]:Show()
			else vexpower.cpsbars[i]:Hide() end
		end
		vexpower.cpsbars[i]:SetWidth(width)
		vexpower.cpsbars[i]:ClearAllPoints()
		vexpower.cpsbars[i]:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT", start[i], vexpower_parameters["frame"]["combo"]["measure"]["y"])
		
		vexpower.cpsbars_anigrps[i] = vexpower.cpsbars[i]:CreateAnimationGroup("vexpower.cpsbars_anigrps["..i.."]")
		vexpower.cpsbars_anigrps[i]:SetLooping("NONE")
		vexpower.cpsbars_anigrps[i]:SetScript("OnPlay", function () vexpower.cpsbars[i]:Show() end)
		vexpower.cpsbars_anigrps[i]:SetScript("OnFinished", function () vexpower.cpsbars[i]:Hide() end)
		vexpower.cpsbars_anis[i] = vexpower.cpsbars_anigrps[i]:CreateAnimation("Alpha")
		vexpower.cpsbars_anis[i]:SetDuration(animationduration)
		vexpower.cpsbars_anis[i]:SetOrder(1)
		vexpower.cpsbars_anis[i]:SetChange(-1)
		
	end
end

function vexpower_setEnergybarBG()
	vexpower_energybarbg:SetBackdrop({bgFile=vexpower.LSM:Fetch("background", vexpower_parameters["frame"]["energy"]["bg_texture"]),
									edgeFile=vexpower.LSM:Fetch("border", vexpower_parameters["frame"]["energy"]["border"]["texture"]), tile=false,
										edgeSize=vexpower_parameters["frame"]["energy"]["border"]["size"]})
	vexpower_energybarbg:SetBackdropColor(	vexpower_parameters["frame"]["energy"]["bgcolor"]["r"],
											vexpower_parameters["frame"]["energy"]["bgcolor"]["g"],
											vexpower_parameters["frame"]["energy"]["bgcolor"]["b"],
											vexpower_parameters["frame"]["energy"]["bgcolor"]["a"])
	vexpower_energybarbg:SetBackdropBorderColor(	vexpower_parameters["frame"]["energy"]["border"]["color"]["r"],
													vexpower_parameters["frame"]["energy"]["border"]["color"]["g"],
													vexpower_parameters["frame"]["energy"]["border"]["color"]["b"],
													vexpower_parameters["frame"]["energy"]["border"]["color"]["a"])
	vexpower_energybarbg:SetWidth(vexpower_parameters["frame"]["energy"]["size"]["width"])
	vexpower_energybarbg:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"])
	vexpower_energybarbg:ClearAllPoints()
	vexpower_energybarbg:SetPoint("CENTER", vexpower_MainFrame, "CENTER", 0, 0)
	vexpower_energybarbg:SetFrameStrata("LOW")
	vexpower_energybarbg:RegisterForDrag("LeftButton")
	vexpower_energybarbg:SetScript("OnDragStart", function () vexpower_MainFrame:StartMoving() end)
	vexpower_energybarbg:SetScript("OnDragStop", function () vexpower_MainFrame:StopMovingOrSizing() vexpower_saveFramePos() end)
	vexpower_energybarbg:SetMovable(false)
	vexpower_energybarbg:EnableMouse(false)
end

function vexpower_setEnergybar()
	if vexpower_parameters["frame"]["energy"]["textureToUse"] == 1 then
		vexpower_energybar:SetBackdrop({bgFile=vexpower.LSM:Fetch("background", vexpower_parameters["frame"]["energy"]["bg"]), tile=false,
								edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
	else
		vexpower_energybar:SetBackdrop({bgFile=vexpower.LSM:Fetch("statusbar", vexpower_parameters["frame"]["energy"]["bg2"]), tile=false,
								edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
	end
	vexpower_setEnergybarColor()
	vexpower_energybar:SetBackdropBorderColor(1,1,1,0)
	
	if not(vexpower.testmode) then
		if vexpower.class == "WARRIOR" or vexpower.class == "DEATHKNIGHT" then vexpower_energybar:SetWidth(1)
		else vexpower_energybar:SetWidth(vexpower.maxwidth) end
		vexpower_energybar:Show()
	end
	vexpower_energybar:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2))
	vexpower_energybar:ClearAllPoints()
	vexpower_energybar:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT",
						vexpower_parameters["frame"]["energy"]["border"]["size"],
						-vexpower_parameters["frame"]["energy"]["border"]["size"])
	vexpower_energybar_anigrp = vexpower_energybar:CreateAnimationGroup("vexpower_energybar_anigrp")
	vexpower_energybar_anigrp:SetLooping("NONE")
	vexpower_energybar_ani = vexpower_energybar_anigrp:CreateAnimation("Scale")
	vexpower_energybar_ani:SetSmoothing("OUT")
	vexpower_energybar_ani:SetDuration(0.2)
	vexpower_energybar_ani:SetOrder(1)
	vexpower_energybar_ani:SetOrigin("TOPLEFT",0,0)
end

function vexpower_setMainFrame()
	vexpower_MainFrame:SetWidth(1)
	vexpower_MainFrame:SetHeight(1)
	vexpower_MainFrame:ClearAllPoints()
	vexpower_MainFrame:SetPoint(vexpower_parameters["frame"]["energy"]["position"]["anchorFrame"],
									UIParent,
									vexpower_parameters["frame"]["energy"]["position"]["anchor"],
									vexpower_parameters["frame"]["energy"]["position"]["x"],
									vexpower_parameters["frame"]["energy"]["position"]["y"])
end

function vexpower_setcpsbar()
	vexpower_cpsbar:SetWidth(1)
	vexpower_cpsbar:SetHeight(1)
	vexpower_cpsbar:ClearAllPoints()
	vexpower_cpsbar:SetPoint("TOPLEFT", vexpower_setMainFrame, "TOPLEFT", 0, 0)
end

function vexpower_setEnergybarColor()
	local coloring = {}
	coloring = vexpower_getEnergyBarColor()
	if coloring[1] == "standard" then
		if coloring[2] then
			vexpower_energybar:SetBackdropColor(	PowerBarColor[vexpower.energytype].r,
													PowerBarColor[vexpower.energytype].g,
													PowerBarColor[vexpower.energytype].b,
													vexpower_parameters["frame"]["energy"]["color"]["a"])
		else
			vexpower_energybar:SetBackdropColor(	vexpower_parameters["frame"]["energy"]["color"]["r"],
													vexpower_parameters["frame"]["energy"]["color"]["g"],
													vexpower_parameters["frame"]["energy"]["color"]["b"],
													vexpower_parameters["frame"]["energy"]["color"]["a"])
		end
	else
		if coloring[2] then
			vexpower_energybar:SetBackdropColor(	PowerBarColor[vexpower.energytype].r,
													PowerBarColor[vexpower.energytype].g,
													PowerBarColor[vexpower.energytype].b,
													vexpower_parameters["frame"]["energy"]["altcolors"][coloring[1]]["a"])
		else
			vexpower_energybar:SetBackdropColor(	vexpower_parameters["frame"]["energy"]["altcolors"][coloring[1]]["r"],
													vexpower_parameters["frame"]["energy"]["altcolors"][coloring[1]]["g"],
													vexpower_parameters["frame"]["energy"]["altcolors"][coloring[1]]["b"],
													vexpower_parameters["frame"]["energy"]["altcolors"][coloring[1]]["a"])
		end
	end
end

function vexpower_getEnergyBarColor()
	local situation = 0
	local perc_energy = 0.5
	local returnvalue = {}
	returnvalue[1] = "standard"
	returnvalue[2] = vexpower_parameters["frame"]["energy"]["typecolored"]
	if vexpower.maxenergy ~= 0 then
		perc_energy = vexpower.currentenergy / vexpower.maxenergy
	end
	
	if vexpower.infight then
		if perc_energy < vexpower_parameters["frame"]["energy"]["altcolors"]["empty"] 		then situation = 1
		elseif perc_energy > vexpower_parameters["frame"]["energy"]["altcolors"]["full"]	then situation = 3
		else					 																 situation = 2
		end
	else
		if perc_energy < vexpower_parameters["frame"]["energy"]["altcolors"]["empty"] 		then situation = 4
		elseif perc_energy > vexpower_parameters["frame"]["energy"]["altcolors"]["full"]	then situation = 6
		else					 																 situation = 5
		end
	end
	if vexpower_parameters["frame"]["energy"]["altcolors"]["use"][situation] then
		returnvalue[1] = tostring(situation)
		returnvalue[2] = vexpower_parameters["frame"]["energy"]["altcolors"]["typecolored"][situation]
	end
	return returnvalue
end

function vexpower_setEnergyTextbar()
	vexpower_energyTextbar:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeFile="Interface\\Buttons\\WHITE8X8", edgeSize=1})
	vexpower_energyTextbar:SetBackdropColor(0, 0, 0, 0)
	vexpower_energyTextbar:SetBackdropBorderColor(1,1,1,0)
	vexpower_energyTextbar:SetWidth(vexpower.maxwidth)
	vexpower_energyTextbar:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2))
	vexpower_energyTextbar:ClearAllPoints()
	vexpower_energyTextbar:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT",
						vexpower_parameters["frame"]["energy"]["border"]["size"],
						-vexpower_parameters["frame"]["energy"]["border"]["size"])
end

function vexpower_setEnergybarDif()
	vexpower_energybarDif:SetBackdrop({bgFile="Interface\\Buttons\\WHITE8X8", edgeFile="Interface\\Buttons\\WHITE8X8", tile=false, edgeSize=1})	
	vexpower_energybarDif:SetBackdropColor(	vexpower_parameters["frame"]["energy"]["usedcolor"]["r"],
											vexpower_parameters["frame"]["energy"]["usedcolor"]["g"],
											vexpower_parameters["frame"]["energy"]["usedcolor"]["b"],
											vexpower_parameters["frame"]["energy"]["usedcolor"]["a"])
	vexpower_energybarDif:SetBackdropBorderColor(1,1,1,0)
	if not(vexpower.testmode) then
		vexpower_energybarDif:SetWidth(0)
		vexpower_energybarDif:Hide()
	end
	vexpower_energybarDif:SetHeight(vexpower_parameters["frame"]["energy"]["size"]["height"]-(vexpower_parameters["frame"]["energy"]["border"]["size"]*2))
	vexpower_energybarDif:ClearAllPoints()
	vexpower_energybarDif:SetPoint("TOPLEFT", vexpower_energybarbg, "TOPLEFT",
						vexpower_parameters["frame"]["energy"]["border"]["size"],
						-vexpower_parameters["frame"]["energy"]["border"]["size"])
	vexpower_energybarDif_anigrp = vexpower_energybarDif:CreateAnimationGroup("vexpower_energybarDif_anigrp")
	vexpower_energybarDif_anigrp:SetLooping("NONE")
	vexpower_energybarDif_anigrp:SetScript("OnPlay", function () vexpower_energybarDif:Show() end)
	vexpower_energybarDif_anigrp:SetScript("OnFinished", function () vexpower_energybarDif:Hide() end)
	vexpower_energybarDif_ani = vexpower_energybarDif_anigrp:CreateAnimation("Alpha")
	vexpower_energybarDif_ani:SetDuration(0.5)
	vexpower_energybarDif_ani:SetOrder(1)
	vexpower_energybarDif_ani:SetChange(-1)
end

function vexpower_setFontStrings()
	-- FontString 1
	vexpower_energytext_left:ClearAllPoints()
	vexpower_energytext_left:SetPoint("TOPLEFT", vexpower_energyTextbar, "TOPLEFT" , vexpower_parameters["frame"]["energy"]["text"]["left"]["x"], vexpower_parameters["frame"]["energy"]["text"]["left"]["y"])
	vexpower_energytext_left:SetTextColor(vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["color"]["a"])
	vexpower_energytext_left:SetFont(vexpower.LSM:Fetch("font", vexpower_parameters["frame"]["energy"]["text"]["left"]["font"]),
									vexpower_parameters["frame"]["energy"]["text"]["left"]["size"],
									vexpower_parameters["frame"]["energy"]["text"]["left"]["effect"])	
	vexpower_energytext_left:SetWidth(vexpower_parameters["frame"]["energy"]["text"]["left"]["width"])	
	vexpower_energytext_left:SetJustifyH(vexpower_parameters["frame"]["energy"]["text"]["left"]["align"])
	if vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["allow"] then	
		vexpower_energytext_left:SetShadowColor(vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["color"]["a"])
		vexpower_energytext_left:SetShadowOffset(vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["offset"]["x"],
											vexpower_parameters["frame"]["energy"]["text"]["left"]["shadow"]["offset"]["y"])
	else
		vexpower_energytext_left:SetShadowColor(0, 0, 0, 0)
		vexpower_energytext_left:SetShadowOffset(0, 0)
	end
	
	
	-- FontString 2
	vexpower_energytext_right:ClearAllPoints()
	vexpower_energytext_right:SetPoint("TOPRIGHT", vexpower_energyTextbar, "TOPRIGHT" , vexpower_parameters["frame"]["energy"]["text"]["right"]["x"], vexpower_parameters["frame"]["energy"]["text"]["right"]["y"])
	vexpower_energytext_right:SetTextColor(vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["color"]["a"])
	vexpower_energytext_right:SetFont(vexpower.LSM:Fetch("font", vexpower_parameters["frame"]["energy"]["text"]["right"]["font"]),
									vexpower_parameters["frame"]["energy"]["text"]["right"]["size"],
									vexpower_parameters["frame"]["energy"]["text"]["right"]["effect"])	
	vexpower_energytext_right:SetWidth(vexpower_parameters["frame"]["energy"]["text"]["right"]["width"])	
	vexpower_energytext_right:SetJustifyH(vexpower_parameters["frame"]["energy"]["text"]["right"]["align"])
	
	if vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["allow"] then	
		vexpower_energytext_right:SetShadowColor(vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["r"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["g"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["b"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["color"]["a"])
		vexpower_energytext_right:SetShadowOffset(vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["offset"]["x"],
											vexpower_parameters["frame"]["energy"]["text"]["right"]["shadow"]["offset"]["y"])
	else
		vexpower_energytext_right:SetShadowColor(0, 0, 0, 0)
		vexpower_energytext_right:SetShadowOffset(0, 0)
	end
	
end

function vexpower_ShowCPs()
	for i=1, #vexpower.cpsbars do
		if vexpower.cpsbars[i] ~=nil then
			if i <= vexpower.currentcps then
				vexpower.cpsbars[i]:Show()
			else
				vexpower.cpsbars[i]:Hide()
			end
		end
	end
end

function vexpower_showEnergybars()
	local show = true
	
	--check for enabled addon
	if vexpower_parameters["frame"]["show"] then
		--check for infight
		if vexpower_parameters["frame"]["infightshow"] and vexpower.infight	then
			show = true
		elseif not(vexpower_parameters["frame"]["infightshow"])	then
			show = true
		else
			show = false
		end
		
		--check for stealth
		if vexpower_parameters["frame"]["stealthshow"] and vexpower.stealth then
			show = true
		end
		
		--check for show not with manapool
		if not(vexpower_parameters["frame"]["energy"]["showwithmana"]) and vexpower.energytype == "MANA" then
			show = false
		end		
	else
		show = false
	end
	
	vexpower.show = show
	
	local show_energy = show
	local show_cps = show
	
	if not(vexpower_parameters["frame"]["combo"]["showWithoutEnergy"]) and vexpower.energytype ~= "ENERGY" then
		show_cps = false
	end
	
	if not(vexpower_parameters["frame"]["energy"]["show"]) then
		show_energy = false
	end
	
	if not(vexpower_parameters["frame"]["combo"]["show"]) then
		show_cps = false
	end
	
	--react to 'show'
	if show_energy then 	vexpower_energybarbg:Show() 
	else					vexpower_energybarbg:Hide() end
	
	if show_cps then		vexpower_cpsbar:Show() vexpower_ShowCPs()
	else					vexpower_cpsbar:Hide() end
end







